//---------------------------------------------------------------------
// Copyright (C)2002 Matt J. Scott.
//
// This file is subject to the terms and conditions of the GNU General
// Public License Version 2.  See the file "COPYING" in the main
// directory of this archive for more details
//---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include "pack.h"

SStripMesh limb;

bool LoadStripMesh(char *filename, SStripMesh *pMesh) {
	int32  amtRead;
	int32  fileLen;
	uint32 vertCnt;
	FILE   *fpstripmsh;

	// open file and get info
	if ((fpstripmsh = fopen(filename, "rb")) == NULL) {
		printf ("ERROR: could not open stripmesh\n");
		return false;
	}

	// read header
	amtRead = fread(&pMesh->mshHdr, sizeof (char), 
			sizeof(SMeshHdr), fpstripmsh);

	if (amtRead == sizeof(SMeshHdr)) {
		// malloc memory
		pMesh->pStrips	= 
			(SStripHdr*) malloc(sizeof(SStripHdr) * pMesh->mshHdr.numStrips);
		pMesh->pVerts	= 
			(LTVector4f*)malloc(sizeof(LTVector4f) * pMesh->mshHdr.numVerts);
		pMesh->pNorms	= 
			(LTVector4f*)malloc(sizeof(LTVector4f) * pMesh->mshHdr.numVerts);
		pMesh->pCols	= 
			(LTVector4f*)malloc(sizeof(LTVector4f) * pMesh->mshHdr.numVerts);
		pMesh->pUVs		= 
			(LTVector2f*)malloc(sizeof(LTVector2f) * pMesh->mshHdr.numVerts);

		// read in data
		fread (pMesh->pStrips, sizeof(SStripHdr), 
				pMesh->mshHdr.numStrips, fpstripmsh);
		fread (pMesh->pVerts, sizeof(LTVector4f), 
				pMesh->mshHdr.numVerts, fpstripmsh);
		fread (pMesh->pNorms, sizeof(LTVector4f), 
				pMesh->mshHdr.numVerts, fpstripmsh);
		fread (pMesh->pCols, sizeof(LTVector4f), 
				pMesh->mshHdr.numVerts, fpstripmsh);
		fread (pMesh->pUVs, sizeof(LTVector2f), 
				pMesh->mshHdr.numVerts, fpstripmsh);
		//
		// close the file
		fclose(fpstripmsh);
	} else {
		printf ("Could not read strip file header\n");
	}
}
