;
;	shell for camera update
; 	camera.cc  : first - part read and decode pads
;

		.include	"basic_vu.i"
		.include	"vumacros.m"
		.include	"spadz.i"
		.include	"gs.m"
		.include	"pads.i"
		.include	"sc.m"

		.init_vf_all
		.init_vi_all

		.syntax		new


	
	move.xyz	cloc,vf00
	loi		0.5
	add.y		cloc,vf00,i

	sq.xyz		cloc,d_cameraLookAt(vi00)	; zero look at!


	
	--barrier


	lq.xyz		camControl,d_camControl(vi00)	; read camera control

	ilw.x		pads,d_icontrolData2(vi00)x	; read pads
	isw.w		pads,d_camControl(vi00)w	; read pads
	


;**************** ZOOM_IN
	isetiu		tmp,PAD_IN
	iand		tmp,tmp,pads
	ibne		tmp,vi00,not_in

       	loi		-0.1
	add.z		camControl,camControl,i

not_in:

;**************** ZOOM_OUT
	isetiu		tmp,PAD_OUT
	iand		tmp,tmp,pads
	ibne		tmp,vi00,not_out

       	loi		0.1
	add.z		camControl,camControl,i

not_out:


       	loi		2.0e-3
	add.x		camControl,camControl,i

;**************** ROTATE_LEFT

	isetiu		tmp,PAD_LEFT
	iand		tmp,tmp,pads
	ibne		tmp,vi00,not_left

       	loi		2.0e-2
	add.x		camControl,camControl,i

not_left:

;**************** ROTATE_RIGHT

	isetiu		tmp,PAD_RIGHT
	iand		tmp,tmp,pads
	ibne		tmp,vi00,not_right

       	loi		-2.0e-2
	add.x		camControl,camControl,i

not_right:

;**************** ROTATE_UP

	isetiu		tmp,PAD_UP
	iand		tmp,tmp,pads
	ibne		tmp,vi00,not_up

       	loi		2.0e-2
	add.y		camControl,camControl,i

not_up:

;**************** ROTATE_UP

	isetiu		tmp,PAD_DOWN
	iand		tmp,tmp,pads
	ibne		tmp,vi00,not_down

       	loi		-2.0e-2
	add.y		camControl,camControl,i

not_down:

;****************
;****************  done pads - so clamp
;**************** 


; CLAMP R [2,12]

	loi		2.0
	max.z		camControl,camControl,i
	loi		12.0
	mini.z		camControl,camControl,i


; CLAMP THETA [ 0.1, 1.9]

	loi		0.1
	max.y		camControl,camControl,i
	loi		1.9
	mini.y		camControl,camControl,i

; MODULAR PHI	[0,4]


	loi		0.25
	mul.x		reg,camControl,i
	add.x		reg,reg,vf00[w]		; 1+(0.25a)
	ftoi0.x		tmp,reg			; to-int
	itof0.x		tmp,tmp			; from-int
	sub.x		reg,reg,tmp		; fractional part
	loi		4.0
	mul.x		camControl,reg,i

;***************** save out!

	sq.xyz		camControl,d_camControl(vi00)


;*************** from all that - build the camera location



	move.xy		cam_ang,camControl
	move.z		cam_ang,vf00


	sincosXYZ	cam_ang,sines,cosines

	
	move.x		cloc,cosines  		; cp -  - 
	add.z		cloc,vf00,sines[x]	; cp -  sp
	add.y		cloc,vf00,cosines[y]	; cp ct sp

	mul.xyz		cloc,cloc,camControl[z]		; r.cp  r.ct - r.sp
	mul.xz		cloc,cloc,sines[y]		; r.cp.st  r.ct  r.sp.st

	sq.xyz		cloc,d_cameraLocation(vi00)




